// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef MEMORY_INST_HH
#define MEMORY_INST_HH

#include <stdint.h>
#include <systemc>

class memory_inst :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > clk;
    sc_core::sc_in< bool > rst;
    sc_core::sc_in< uint16_t > addr;
    sc_core::sc_out< uint8_t > datai;
    sc_core::sc_in< uint8_t > datao;
    sc_core::sc_out< bool > irq_n;
    sc_core::sc_out< bool > nmi_n;
    sc_core::sc_out< bool > sob_n;
    sc_core::sc_out< bool > res_n;
    sc_core::sc_out< bool > rdy;
    sc_core::sc_in< bool > vpab;
    sc_core::sc_in< bool > sync;
    sc_core::sc_in< bool > we_n;
    sc_core::sc_in< bool > oeb;
    sc_core::sc_out< bool > psel1;
    sc_core::sc_out< bool > psel2;
    sc_core::sc_out< bool > psel3;
    sc_core::sc_out< bool > psel4;
    sc_core::sc_out< bool > psel5;
    sc_core::sc_out< bool > psel6;
    sc_core::sc_out< bool > psel7;
    sc_core::sc_out< bool > psel8;
    sc_core::sc_out< bool > penable;
    sc_core::sc_out< bool > presetn;
    sc_core::sc_out< uint32_t > paddr;
    sc_core::sc_out< bool > pwrite;
    sc_core::sc_out< uint32_t > pwdata;
    sc_core::sc_in< bool > pready;
    sc_core::sc_in< uint32_t > prdata;
    uint32_t pwdata_var;
    uint32_t paddr_var;
    sc_core::sc_signal< uint8_t > state;
    uint8_t state_sig_var;
    uint8_t _ram[32768L];
    uint8_t _rom[16384L];
    uint16_t ram_addr;
    uint16_t rom_addr;
    bool addr_firstbit_ram;
    bool addr_firstbit_rom;

    void start_of_simulation();



    SC_HAS_PROCESS( memory_inst );

    memory_inst( sc_core::sc_module_name name_ );
    ~memory_inst();


private:

    memory_inst( const memory_inst & );
    const memory_inst& operator= ( const memory_inst & );


    void process();
    void process_0();
    void process_1();
    void process_2();

};


#endif

